% load('tempdata.mat', 'A5');
% A5 = A5 - diag(ones(14,1));
% B5 = A5;
B = A;
m = size(A,1);
n = size(B,1);
l_node = 2;
node_label1 = ones(m,1);
node_label1(500:m) = 2;
node_label2 = ones(n,1);
node_label2(800:n) = 2;
alpha = 0.8;
max_iter = 1;
CGmax_iter = 100;
tol = 1e-7;
epsilon = 1e-10;
HL = ones(m,1)/(m*n);
HR = ones(1,n);
re = Inf;
k1 = 5;
k2 = 4;

Da = sum(A, 2).^(-0.5);
Db = sum(B, 2).^(-0.5);
Da(Da==Inf) = 0;
Db(Db==Inf) = 0;
Acel = cell(l_node, l_node);
Bcel = cell(l_node, l_node);
XLt = cell(1,l_node);
XRt = cell(1,l_node);
BLt = cell(1,l_node);
BRt = cell(1,l_node);
l = @Moperator_Block_v2;
for i=1:l_node
    [rn1,cn1,~] = find(node_label1 == i);
    [rn2,cn2,~] = find(node_label2 == i);        
    N1i = sparse(rn1, cn1, 1, m, 1);
    N2i = sparse(rn2, cn2, 1, n, 1);
    for j = 1:l_node
        
        [rn3,cn3,~] = find(node_label1 == j);
        [rn4,cn4,~] = find(node_label2 == j);
        
        N1j = sparse(rn3, cn3, 1, m, 1);
        N2j = sparse(rn4, cn4, 1, n, 1);
        
        if i == j
            BLt{j} = bsxfun(@times, N2j, ones(m,1)/((m*n)^0.5));
            BRt{j} = bsxfun(@times, ones(1,n)/((m*n)^0.5), N1j');
            XLt{j} = sparse(m,1);
            XRt{j} = sparse(1,n);
        end

        An = bsxfun(@times, bsxfun(@times, N1i, A), N1j');
        Bn = bsxfun(@times, bsxfun(@times, N2i, B), N2j');
 
        Aj = alpha^(0.5)*bsxfun(@times, bsxfun(@times, Da, An), Da');
        Bj = alpha^(0.5)*bsxfun(@times, bsxfun(@times, Db, Bn), Db');

        Acel{i, j} = Aj;
        Bcel{i, j} = Bj;
    end
end


Re0L = HL;
Re0R = HR;
re = norm(Re0L*Re0R, 'fro');
iter = 0;flag = 0;
while iter < max_iter
    iter = iter +1;
    
    fprintf('iteration %d ',iter);
    if re < tol
        XBL = Re0L;
        XBR = Re0R;
        flag = 1;
        break;
    else
        for i = 1:l_node
                [Ol, Or] = Operator2_Block_v2(Acel, Bcel, XLt, XRt, l_node, i);
                BL = cat(2, BLt{i}, Ol);
                BR = cat(1, BRt{i}, Or);
            for j = 1:l_node                
                if i == j 
                    % call main4Block
                    [Xs1, Xt1, ~,it1,time] = main4Block_v2(Acel{j, j}, Bcel{j, j}, BL, BR, tol, k1, k1, 1e-10, 20, 100);
                    XLt{i} = -Xs1;
                    XRt{i} = Xt1;
                    fprintf('iter1: %d ',it1);
                    fprintf('time:%d ',time);
                end
%                 if i == j && i ~= 1
% %                     % call main4Block
%                     [Xs1, Xt1, ~, it2, ~] = main4Block_v2(Acel{j, j}, Bcel{j, j}, BL, BR, tol, k2, k2, 1e-10, 30, 100);
%                     XLt{i} = -Xs1;
%                     XRt{i} = Xt1;
%                     fprintf('iter2: %d\n ',it2);
%                 end
            end
        end

        % THIS IS SLOW! CHANGE!
        re =0;
        for t = 1 : l_node
            [ll, lr] =  l(Acel, Bcel, XLt, XRt, l_node, t);
            rel = cat(2, BLt{t}, -XLt{t}, ll);
            rer = cat(1, BRt{t}, XRt{t}, lr);
            for s = 1:size(rel,1)
                re = re + rel(s, :)*rer(:, s);
            end
%             re = re + norm(rel*rer, 'fro');
        end
        fprintf('residual: %d\n', re);
    end
end
