function [X, flag, iter, re, time] = main4Block(Ablk, Bblk, X0, RB, tol, k1, k2, epsilon, max_iter, CGmax_iter)
%% main function of Sylvester Equation method for Attr_Main_Block
% 
% da = sum(A,2);
% db = sum(Aq, 2);
% n1 = size(A, 1);
% n2 = size(Aq, 1);
% % A = alpha^(0.5).*bsxfun(@times, bsxfun(@times, da.^(-0.5), A),
% % (da.^(-0.5))');% not efficient
% % Aq = alpha^(0.5).*bsxfun(@times, bsxfun(@times, db.^(-0.5), Aq),
% % (db.^(-0.5))'); % not efficient
% D1 = sparse(1:n1, 1:n1, da.^(-0.5));
% D2 = sparse(1:n2, 1:n2, db.^(-0.5));
% A(isnan(A))=0;
% Aq(isnan(Aq))=0;
% A = alpha^(0.5).*D1*A*D1;
% Aq = alpha^(0.5).*D2*Aq*D2;

tic;
% X0 = sparse(size(A,1),size(Aq,1));
R0 = RB - Bblk*X0*Ablk' + X0;
iter = 0;flag = 0;
while iter < max_iter
    if toc > 3000
        break
    end
        
    iter = iter +1;
    re = norm(R0,'fro');
%     fprintf('out_iter:%d ', iter);
%     fprintf('residual:%d\n ',re);
    if re < tol
        X = X0;
        flag = 1;
        break
    else
%         start = tic;
        [f,g] = subspace(R0);
        [V,Ha] = arnoldi(Ablk, g, k2);
        [W,Hb] = arnoldi(Bblk, f, k1);

        E = Hb'*W'*R0*V*Ha - W(:,1:k1)'*R0*V(:,1:k2);
        [Y, flag, ~, ~] =  GLCG(sparse(k1,k2), E, epsilon, CGmax_iter, Ha, Hb, k1, k2);
        
        X1 = X0 + W(:, 1:k1)*Y*V(:, 1:k2)';
%         R1 = R0 - W*Hb*Y*Ha'*V' + W(:,1:k1)*Y*V(:,1:k2)'; % same result
%         as follwing line
        R1 = RB - Bblk*X1*Ablk' + X1; % why it works when the - and + are like this
        X0 = X1;
        R0 = R1;
    end
end
X = X0;
time = toc;
end
