function [X, CGflag, CGiter, CG_re] =  GLCG(X0, E, epsilon, CGmax_iter, Ha, Hb, m, n)
%% Global Conjugate Gradient Algorithm

l = @LX;
R0 = E - l(X0, Ha(1:n,:), Hb(1:m,:), Ha, Hb);
P = R0;
R = R0;
CGiter = 0;
CGflag = 0;
X = X0;
while CGiter < CGmax_iter
%    if abs(norm(R)-norm(R0)) <= epsilon
    if norm(R) <= epsilon
        CGflag = 1;
        CG_re = norm(R);
        break;
    else
        R0 = R;
        CGflag = 0;
        alphaj = sum(sum(R0.*R0))/sum(sum(l(P, Ha(1:n,:), Hb(1:m,:), Ha, Hb).*P));
        X = X + alphaj.*P;
        R = R0 -alphaj.*l(P, Ha(1:n,:), Hb(1:m,:), Ha, Hb);
        betaj = sum(sum(R.*R))/sum(sum(R0.*R0));
        P = R + betaj.*P;
        
    end
    CGiter = CGiter+1;
end
CG_re = norm(R);
end